<?php

if ($ldap_directory=="yes")
{
    require("include/ldap-resolv.php");
}

function sql2ip($var) {
	global $nufw_version;
	if ($nufw_version == "2.2"){
		# shift binary
		$ip = unpack("N4",$var);
	        return long2ip($ip[4]);
	} else {
		settype($var, "double");
		return long2ip($var);
	}
}


function setURIstate($uri,$state) {
  if (preg_match('/\/$/',$uri))
    return $uri;
  $newuri=preg_replace('/state=[^&]*/',"state=$state",$uri);
  if (($newuri == $uri)and(!preg_match('/state=/',$uri)))
  {
    if (!preg_match('/\?/',$newuri))
      $newuri.="?state=$state";
    else
      $newuri.="&state=$state";
  }
  return $newuri;
}
function check_start($start) {
  if (!preg_match('/^\d+$/',$start))
    $start=0;
    return $start;
}
function check_order($order) {
  if (($order != 'last_time')&&($order!='first_time')&&($order!='count'))
    $order='last_time';
    return $order;
}

function getHeader($index,$title,$obj,$vnumber) {
	global $start,$order,$lang,$first_message,$last_message,$pckts_message;

	$img_order="<img border=0 width=20 height=15 valign=bottom src=images/down.gif>";

	$header="<tr class=div_header><td class=div_header id=title colspan=3>";
	$header.="<h3>$title</h3></td>
	<td class=div_header id=range align=right colspan=1>( $start[$index], ".($start[$index]+$vnumber-1)." )</td></tr>";
	$header.="<tr class=t_header>";
	$header.="<td>$obj</td>";
	$header.="<td><a href=javascript:reload($index,null,'count')>".$pckts_message;
	if($order[$index]=="count") $header.=$img_order;
	$header.="</a></td><td><a href=javascript:reload($index,null,'first_time')>".$first_message;
	if($order[$index]=="first_time") $header.=$img_order;
	$header.="</a></td><td><a href=javascript:reload($index,null,'last_time')>".$last_message;
	if($order[$index]=="last_time") $header.=$img_order;
	$header.="</a></td></tr>";

	return $header;
}

function clean_username($username){
    global $preuser,$postuser,$system_is_case_insensitive;
    if($system_is_case_insensitive){
        $i="i";
    } else {
        $i="";
    }
    if (isset($preuser)){
        $username=preg_replace("/^$preuser\\\\*/$i","",$username);
    }
    if (isset($postuser)){
        $username=preg_replace("/$postuser\$/","",$username);
    }
    return $username;
}

function packet_query($pheader,$query,$link_prev,$link_next,$state) {
        global $nufw_enabled,$lang,$type_message,$packet_id_message,$user_message,$src_message,$dest_message,$proto_message,$sport_message,$dport_message,$date_message,$log_prefix_message;
	$header=$pheader;
        if ($nufw_enabled == "yes"){
	    	  $header.="<tr class=t_header><td>$type_message</td><td>".$packet_id_message."</td><td>$user_message</td><td>$src_message</td><td>$dest_message</td><td>$proto_message</td><td>$sport_message</td><td>$dport_message</td><td>$date_message</td><td>$log_prefix_message</td></tr>";
        }else{
	    	  $header.="<tr class=t_header><td>".$packet_id_message."</td><td>$src_message</td><td>$dest_message</td><td>$proto_message</td><td>$sport_message</td><td>$dport_message</td><td>$date_message</td><td>$log_prefix_message</td></tr>";
        }

	put_table($query,$header,"print_row_packet",$link_prev,$link_next,$state);
}

# purge cache table
function clear_cache(){
    global $nufw_enabled;
    global $machine_suffix;
# clear offender cache
    $query="delete from offenders${machine_suffix};";
    mysql_query($query)  or die("Invalid query : $query");

# clear tcp cache
    $query="delete from tcp_ports${machine_suffix};";
    mysql_query($query)  or die("Invalid query : $query");

# clear udp cache
    $query="delete from udp_ports${machine_suffix};";
    mysql_query($query)  or die("Invalid query : $query");

#clear usersstats cache
    if ($nufw_enabled == "yes"){
      $query="delete from usersstats${machine_suffix};";
      mysql_query($query) or die ("Invalid query : $query");
    }

    $query = "delete from cache_task;";
    mysql_query($query)  or die("Invalid query : $query");
}



function put_table($query,$header,$func_print_row,$link_prev,$link_next,$state) {
    global $sql_time;

    echo "<table class=header>";
    echo "<tr><td colspan=2><table class=content>";
    #echo "<tr><td colspan=2><table border=1>";
    echo "<thead>\n";
    echo $header;
    echo "</thead>\n";
    echo "<tbody>\n";

    $sql_time_tmp=getmicrotime();
    $result=mysql_query($query) or die ("query invalid :".$query);
    $sql_time+=getmicrotime()-$sql_time_tmp;

    while ($ligne = mysql_fetch_row($result)){
        $func_print_row($ligne,$state);
    }

    echo "</tbody>\n";
    echo "</table></td></tr>";

    //put previous and next
    print_table_footer($link_prev,$link_next);

    echo "</table>";
}

function print_row_host($ligne,$state) {
    global $date_format;

    echo "<tr><td><a href=host.php?state=$state&host=".$ligne[0]." > ".sql2ip($ligne[0])."</a></td><td> $ligne[1] </td>";
    echo "<td>".date($date_format,$ligne[2])."</td>";
    echo "<td>".date($date_format,$ligne[3])."</td></tr>";
}

function print_row_user($ligne,$state) {
    global $date_format;

    echo "<tr><td><a href=user.php?state=$state&userid=".$ligne[0]."&query=direct > ".clean_username($ligne[1])."</a></td><td><a href=user.php?userid=".$ligne[0]."&query=direct&state=0 > $ligne[2]</a> </td>";
    echo "<td>".date($date_format,$ligne[3])."</td>";
    echo "<td>".date($date_format,$ligne[4])."</td></tr>";
}

function print_row_tcp($ligne,$state) {
    global $date_format;

    echo "<tr><td><a href=port.php?state=$state&proto=tcp&port=".$ligne[0]." > ".$ligne[0]."</a></td><td> $ligne[1] </td>";
    echo "<td>".date($date_format,$ligne[2])."</td>";
    echo "<td>".date($date_format,$ligne[3])."</td></tr>";
}

function print_row_udp($ligne) {
    global $date_format;

    echo "<tr><td><a href=port.php?proto=udp&port=".$ligne[0]." > ".$ligne[0]."</a></td><td> $ligne[1] </td>";
    echo "<td>".date($date_format,$ligne[2])."</td>";
    echo "<td>".date($date_format,$ligne[3])."</td></tr>";
}


function str_rev_ip($str)
{
	global $host_endian;
	if ($host_endian == 1) {
		return $str;
	} else {
		$ar=explode(".",$str);
		return "$ar[3].$ar[2].$ar[1].$ar[0]";
	}
}
      
function print_row_usersession($ligne,$state) {
    global $date_format,$filter_by_host;

    echo "<tr>
    	<td><a href=user.php?state=$state&userid=".$ligne[0]."&query=direct > ".clean_username($ligne[1])."</a></td>
	<td><a href=user.php?host=".$ligne[2]." title=\"$filter_by_host\"> ";
    echo str_rev_ip(sql2ip($ligne[2]))."</a> </td>";
    echo "<td>".$ligne[3]."</td>";
    #echo "<td>".date($date_format,$ligne[4])."</td></tr>";
    echo "<td>".$ligne[4]."</td></tr>";
}

function print_row_usersession_all($ligne,$state) {
    global $date_format,$filter_by_host;

    echo "<tr>
    	<td><a href=user.php?type=histo&userid=".$ligne[0]." > ".clean_username($ligne[1])."</a></td>
	<td><a href=user.php?type=histo&host=".$ligne[2]." title=\"$filter_by_host\"> ";
    echo str_rev_ip(sql2ip($ligne[2]))."</a> </td>";
    echo "<td>".$ligne[3]."</td>";
    #echo "<td>".date($date_format,$ligne[4])."</td></tr>";
    echo "<td>".$ligne[4]."</td>";
    echo "<td>".$ligne[5]."</td></tr>";
}

function print_row_usersession_noos($ligne,$state) {
    global $date_format,$filter_by_host,$url_base;

    echo "<tr>
    	<td><a href=$url_base/user.php?state=$state&userid=".$ligne[0]."&query=direct > ".clean_username($ligne[1])."</a></td>
	<td><a href=$url_base/user.php?host=".$ligne[2]." title=\"$filter_by_host\"> ";
    echo str_rev_ip(sql2ip($ligne[2]))."</a> </td>";
    #echo "<td>".date($date_format,$ligne[4])."</td></tr>";
    echo "<td>".$ligne[4]."</td></tr>";
}



function print_row_packet($ligne,$state) {
    global $date_format,$states_tab,$nufw_enabled,$colorize_entries, $destport;
    global $nuface_link, $nuface_url;
    global $netfilter_log_drop;

    $proto=getprotobynumber($ligne[2]);

    echo "<tr";
    if (($colorize_entries =="yes") && ($nufw_enabled == "yes"))
    {
    	if ($states_tab[$ligne[12]]) {
      		echo " class=\"".$states_tab[$ligne[12]]."\"";
      	} elseif ($netfilter_log_drop == 1) {
      		echo " class=\"drop\"";
	}
    }

    echo ">";
    if ($nufw_enabled == "yes"){
    	if ($ligne[11]){
	echo "<td><img src=images/user.gif alt=authenticated/></td>";
	} else {
	echo "<td><img src=images/host.gif alt=unauthenticated/></td>";
	}
    }
    if ($ligne[9] != NULL) {
	    echo "<td><a href=packet.php?id=".$ligne[9]."&state=".$ligne[12].">".$ligne[9]."</a></td>";
    } else {
	    echo "<td><a href=packet.php?id=".$ligne[9]."&state=-1>".$ligne[9]."</a></td>";
    }
    if ($nufw_enabled == "yes")
    {
          echo "<td><a href=user.php?query=direct&userid=".$ligne[10]."&state=".$state.">".clean_username($ligne[11])."</a></td>";
    }
    echo "<td><a href=host.php?host=".$ligne[0]."&state=".$state." > ".sql2ip($ligne[0])."</a></td>";
    echo "<td><a href=host.php?host=".$ligne[1]."&state=".$state."&query_order=d>".sql2ip($ligne[1])."</a></td><td>$proto</td>";
    echo "<td>";
    if ( ! is_null($ligne[4]))
        echo $ligne[4];
    elseif (! is_null($ligne[6]))
      echo $ligne[6];
    echo "</td><td>";
    if ( ! is_null($ligne[5])){
        $serv=getservbyport($ligne[5],$proto);
        if (strlen($serv)==0) {
		if ($destport == "yes")
			echo "<a href=port.php?proto=$proto&port=$ligne[5]>$ligne[5]</a>";
		else
			echo "$ligne[5]";
	} else {
		if ($destport == "yes")
            		echo "<a href=port.php?proto=$proto&port=$ligne[5]>$serv</a>";
		else
			echo "$serv";
	}
    }
    elseif (! is_null($ligne[7])){
        $serv=getservbyport($ligne[7],$proto);
        if (strlen($serv)==0) {
		if ($destport == "yes")
            		echo "<a href=port.php?proto=$proto&port=$ligne[7]>$ligne[7]</a>";
		else
			echo "$ligne[7]";
        } else {
		if ($destport == "yes")
            		echo "<a href=port.php?proto=$proto&port=$ligne[7]>$serv</a>";
		else
			echo "$serv";
	}
    }
    if ($nuface_link){
	if (preg_match("/^(\d+):/", $ligne[8],$matches)){
		$display_prefix=preg_replace("/^\d+:/","",$ligne[8]);
		$prefix="<a href=".$nuface_url."?nulog=1&acl=".$matches[1]." >".$display_prefix."</a>";
	} else {
		$prefix=$ligne[8];
	}
	} else {
		$prefix=$ligne[8];
	}
    echo"</td><td>".date($date_format,$ligne[3])."</td><td>".$prefix."</td></tr>\n";
}

function print_table_footer($link_prev,$link_next) {
    global $lang,$prev_message,$next_message;
    echo "<tr class=header><td align=left>";
    echo "<a href=$link_prev>$prev_message</a>";
    echo "</td><td align=right>";
    echo "<a href=$link_next>$next_message</a>";
    echo "</td></tr>";
}

function number_of_entries(){
	global $table_ulog;
	$query="select count(*) from $table_ulog" ;
    	$result = mysql_query($query) or die("Invalid query : $query");
    	$ligne = mysql_fetch_row($result);
   	 return $ligne[0];
}

function daily_stats(){
	global $table_ulog;
	$query="select  DAYNAME(timestamp) as DAY, count(*) as CURRENT
	,count(*)*24*3600/(TIME_TO_SEC(CURRENT_TIME())) as ESTIMATE  from
	$table_ulog  where CURRENT_DATE() <timestamp group by
	TO_DAYS(timestamp);";

    	$result = mysql_query($query) or die("Invalid query : $query");
    	$ligne = mysql_fetch_row($result);
	print "$ligne[0] : $ligne[1] ($ligne[2])";

}

function print_load(){
	global $table_ulog,$lang,$load_average_message,$one_min_message,$five_min_message,$fifteen_min_message,$nufw_enabled;


         if ($nufw_enabled){
                    $nufw_flag="and (state is NULL or state=0)";
         }
	$query="select count(*)/60 from $table_ulog where timestamp > NOW()- INTERVAL 1 MINUTE $nufw_flag;";

	$result = mysql_query($query) or die("Invalid query : $query");
    	$ligne = mysql_fetch_row($result);
	print "<table class='indic'>";
	#print "<table border=1>";
	print "<tr><td colspan=2 class=header><h3>".$load_average_message."</h3></td></tr>";
	print "<tr><td class=t_header>".$one_min_message." :</td><td> $ligne[0] pckt/s</td></tr>";
	$load1=$ligne[0];
	$query="select count(*)/300 from $table_ulog where timestamp > NOW()- INTERVAL 5 MINUTE $nufw_flag;";

	$result = mysql_query($query) or die("Invalid query : $query");
    	$ligne = mysql_fetch_row($result);

	print "<tr><td class=t_header>".$five_min_message." :</td><td> $ligne[0] pckt/s</td></tr>";
	$query="select count(*)/900 from $table_ulog where timestamp > NOW()- INTERVAL 15 MINUTE $nufw_flag;";
	$result = mysql_query($query) or die("Invalid query : $query");
    	$ligne = mysql_fetch_row($result);
	print "<tr><td class=t_header>".$fifteen_min_message." :</td><td> $ligne[0] pckt/s</td></tr>";
	print "</table>";
	return $load1;
	}

function print_badhosts($limit=3){
	global $table_ulog,$nufw_enabled,$state_drop,$lang,$bad_hosts_message,$pckts_message;
                 if ($nufw_enabled){
                    $nufw_flag="and state is NULL";
                 }
		$query="select ip_saddr,count(*)/300 as RATE from $table_ulog where (timestamp > NOW()- INTERVAL 5 MINUTE) $nufw_flag group by ip_saddr order by RATE desc limit $limit;";
		$result = mysql_query($query) or die("Invalid query : $query");

	#print "<table border=1>";
	print "<table class='indic'>";
	print "<tr><td><h3>$bad_hosts_message </h3></td><td>$pckts_message/s</td></tr>";
    		while ($ligne = mysql_fetch_row($result)){
			print "<tr><td class=t_header ><a href=host.php?host=".$ligne[0]." >
			".sql2ip($ligne[0])."</a></td><td> ".$ligne[1]."</td></tr>";
		}

	print "</table>";
}

function print_offending_users($limit=3){
	global $table_ulog, $state_drop,$preuser,$postuser,$lang,$offending_users_message,$pckts_message;
		$query="select user_id,username,count(*)/300 as RATE from $table_ulog where timestamp > NOW()- INTERVAL 5 MINUTE AND username NOT LIKE \"\" AND state=$state_drop group by user_id order by RATE desc limit $limit;";
		$result = mysql_query($query) or die("Invalid query : $query");

	#print "<table border=1>";
        if (mysql_num_rows($result)>=1)
        {
	print "<table class='indic'>";
	print "<tr><td><h3>$offending_users_message </h3></td><td>$pckts_message/s</td></tr>";
    		while ($ligne = mysql_fetch_row($result)){
    			settype($ligne[0], "double");
                       			print "<tr><td class=t_header ><a href=user.php?query=direct&state=0&&userid=".clean_username($ligne[0])." >
			".clean_username($ligne[1])."</a></td><td> ".$ligne[2]."</td></tr>";
		}

	print "</table>";
        }
}

function resolve_user($userid){
        global $table_ulog;
        $query="select username from $table_ulog where user_id = $userid order by timestamp DESC limit 1";
	$result = mysql_query($query) or die("Invalid query : $query");
        $ligne = mysql_fetch_row($result);
        return($ligne[0]);
}

function print_tables_list(){
        global $table_basename;
        $query="show tables;";
	$result = mysql_query($query) or die("Invalid query : $query");
        echo "<select name='suffix'>\n";
        while ($row = mysql_fetch_row($result)) {
          if (preg_match("/^${table_basename}/",$row[0])) {
            if ($row[0]==$table_basename.$_SESSION['machine_suffix']){
              printf("<option selected>%s</option>", $row[0]);
            } else {
              printf("<option>%s</option>", $row[0]);
            }
          }
        }
        echo "</select>";
}

function build_and_state_query($state) {
	global $nufw_enabled;
	if (($nufw_enabled=="yes") and ($state!=-1)) {
		if ($state==4) {
			$and_state_query="AND (state=1 OR state=2)";
		} elseif ($state == 0){
			$and_state_query="AND (state=0 OR state is NULL)";
		} else {
			$and_state_query="AND state=$state ";
		}
		return $and_state_query;
	}
	return "";
}

function print_users_table($basepage,$start,$number,$order,$index) {
	global $machine_suffix;
	global $global_user_stats_message;
	global $top_user_connections_message;
	global $username_message;
	global $bad_connections_message;
	global $good_connections_message;
	global $last_seen_message;

	if (!isset($order)){
		$order="last_time";
	}
	$header=getHeader(3,'<img src="images/user.gif" alt="global" border=0>' .  $top_user_connections_message.":",$username_message,$number);
	$query="select user_id,username,bad_conns as count,first_time,last_time from usersstats${machine_suffix} order by $order DESC limit $start,$number";

	put_table($query,$header,"print_row_user",
	"javascript:reload($index,".max($start[$index]-$number,0).",null);","javascript:reload($index,".($start[$index]+$number).",null);"
	,$state);

}

function display_raw_mac_info($rawstring) {
    preg_match(
        "/(\w+:\w+:\w+:\w+:\w+:\w+):(\w+:\w+:\w+:\w+:\w+:\w+):(\w+:\w+)/",
        $rawstring,$matches);
    return "<td>".strtoupper($matches[1])."</td><td>".strtoupper($matches[2])
                ."</td><td>".strtoupper($matches[3])."</td>";
}

function print_usersession($start=0,$number=30,$mode="full",$filter="") {
	global $users_sessions_main_message;
	global $lang,$os_sysname_message, $session_start_time_message;
	global $session_end_time_message;
	global $host_message,$username_message;
	global $_GET;
	$header = "<table class=content><thead>
<tr class=div_header><td class=div_header id=title colspan=3><h3><img src='images/user.gif' alt='' border=0>$users_sessions_main_message:</h3></td>
	<td class=div_header id=range align=right colspan=1>( $start, ".($number+$start-1)." )</td></tr><tr class=t_header><td>$username_message</td>
	<td>$host_message</td>";

	if ($mode != "noos") {
		$header .="<td>$os_sysname_message</td>";
	}
	$header .= "<td>$session_start_time_message</td>";
	if ($mode == "all") {
		$header .= "<td>$session_end_time_message</td>";
	}
	$header .= "</tr></thead>
	";
	if ($_GET['host']) {
		$host = intval($_GET['host']);
		if ($filter == "") {
			$filter = "where end_time is NULL and ip_saddr = $host";
		}
	} else {
		if ($filter == "") {
			$filter = "where end_time is NULL";
		}
	}

	$query = "select user_id,username,ip_saddr,os_sysname,start_time,end_time from users $filter   order by start_time DESC limit $start,$number;";

	if ($mode == "noos") {
		put_table($query,$header,"print_row_usersession_noos",
				"?start=".max(0,$start-$number),
				"?start=".($start+$number),
				$state);
	} elseif ($mode == "full") {
		put_table($query,$header,"print_row_usersession",
				"?start=".max(0,$start-$number),
				"?start=".($start+$number),
				$state);
	} elseif ($mode == "all") {
		put_table($query,$header,"print_row_usersession_all",
				"?type=histo&start=".max(0,$start-$number),
				"?type=histo&start=".($start+$number),
				$state);
	}
}

function print_user_state($userid) {
	global $lang,$user_disconnected_message,$user_connected_message;
	 $query = "select username from users where end_time is NULL and user_id = $userid";
	 $result=mysql_query($query) or die ("query invalid :".$query);
	 if (mysql_num_rows($result)>0){
	 	return $user_connected_message;
	 } else {
	 	return $user_disconnected_message;
	}
}

function print_user_session_count() {
	$query = "select user_id from users where end_time is NULL;";
	$result=mysql_query($query) or die ("query invalid :".$query);
	return mysql_num_rows($result);
}

?>
